
data (==) {A : Set}(a : A) : A -> Set where
  refl : a == a

infixr 15 ::, ++

data List (A : Set) : Set where
  nil  : List A
  (::) : A -> List A -> List A

(++) (A : Set) : List A -> List A -> List A
[]	++ ys = ys
(x :: xs) ++ ys = x :: (xs ++ ys)

rotate (A : Set) : List A -> List A
rotate []      = []
rotate (x :: xs) = xs ++ [x]

data Bit : Set where
  O : Bit
  I : Bit

neg : Bit -> Bit
neg O = I
neg I = O

negNegId : (x : Bit) -> neg (neg x) == x
negNegId O = refl
negNegId I = refl

rewrite negNegId

data Alternating : Bit -> List Bit -> Set where
  altCns (x : Bit)(xs : List Bit) : Alternating (neg x) xs -> Alternating x (x :: xs)
  altNil (x : Bit)		  : Alternating x []

data Paired : List Bit -> Set where
  pairCons (x : Bit)(xs : List Bit) : Paired xs -> Paired (x :: neg x :: xs)
  pairUnit (x : Bit)		    : Paired [x]
  pairNil			    : Paired []

data Merge {A : Set} : List A -> List A -> List A -> Set where
  merge1 (x : A)(xs,ys,zs : List A) : Merge xs ys zs -> Merge (x :: xs) ys (x :: zs)
  merge2 (y : A)(xs,ys,zs : List A) : Merge xs ys zs -> Merge xs (y :: ys) (y :: zs)
  mergeNil			: Merge {A} [] [] []

thm (x : Bit)(xs,ys,zs : List Bit) :
     Alternating x xs -> Alternating (neg x) ys -> Merge xs ys zs -> Paired zs
thm  altNil		    altNil		   mergeNil	      = pairNil
thm (altCns altNil)	    altNil		  (merge1  mergeNil)  = pairUnit
thm  altNil		   (altCns altNil)	  (merge2  mergeNil)  = pairUnit
thm (altCns (altCns altX))  altY		  (merge1 (merge1 m)) = pairCons (thm altX altY m)
thm (altCns altX)	   (altCns altY)	  (merge1 (merge2 m)) = pairCons (thm altX altY m)
thm (altCns altX)	   (altCns altY)	  (merge2 (merge1 m)) = pairCons (thm altX altY m)
thm  altX		   (altCns (altCns altY)) (merge2 (merge2 m)) = pairCons (thm altX altY m)

