
module Utils.Lists where

import Data.List

-- | A variant of 'groupBy' that divides a list into constant chunks w.r.t.
--   a given function. For instance:
--
--   > chunks id "aaabccdddeaa" = ["aaa","b","cc","ddd","e","aa"]
chunks :: Eq b => (a -> b) -> [a] -> [[a]]
chunks f xs =
    map (map snd)
	$ groupBy (\ (v,_) (w,_) -> v == w)
	$ map (\x -> (f x, x)) xs

-- | Check if a list is a substring of another list
isSubstringOf :: Eq a => [a] -> [a] -> Bool
isSubstringOf [] _  = True
isSubstringOf _ []  = False
isSubstringOf xs ys = isPrefixOf xs ys || isSubstringOf xs (tail ys)

