{-# OPTIONS -fglasgow-exts #-}

module Utils.Debug
    ( module Utils.Debug
    , module Syntax.Pretty
    , module Utils.Error
    ) where

import Prelude hiding	    ( print, putStr, putStrLn )
import IO.Output

import System.IO.Unsafe (unsafePerformIO)

import Syntax.Pretty
import Utils.Error

class Displayable d where
    display :: d -> String

instance Displayable String where
    display = id

instance Displayable Doc where
    display = show

debug :: Displayable s => s -> a -> a
debug x = seq $ unsafePerformIO (putStrLn $ display x)

